#define nexSer Serial1  // Controlling the Nextion HMI using Serial1 (pin18 of the Arduino Mega) to prevent interfering with code upload
#define dbgSer Serial   // Debug using default Serial over USB towards Arduino Serial Monitor
#define DEBUG           // Comment this out if you don't need to see what happens in the Serial Monitor

void sendCmd(String cmd)
{
  nexSer.print(cmd);
  nexSer.write("\xFF\xFF\xFF");
#ifdef DEBUG
  if(cmd.length() > 0)
  {
    dbgSer.print("Sending command : ");
    dbgSer.println(cmd);
  } else
  {
    dbgSer.println("Empty command issued to clear the buffer");  
  }
#endif
}

void setup() {
  dbgSer.begin(9600);
  while(!dbgSer)
  {
    // wait for connect  
  }
  nexSer.begin(9600);
  while(!nexSer)
  {
    // wait for connect  
  }
  sendCmd(""); // clear the buffer
  sendCmd("t0.txt=\"Hello world\"");
  delay(2000);
}

void loop() {
  //Declare variables
  String mytext;
  String message;
  int8_t i;
   
  //Countdown example
  message = "Countdown: ";
  for (i=10; i>=0; i--)
  {
    mytext = "\"" + message + i + "\"";
    sendCmd("t0.txt=" + mytext);
    delay(1000);
  }

  //Fading in example
  message = "Fading in...";
  for(i=1; i<=message.length(); i++)
  {
    mytext = "\"" + message.substring(0,i) + "\"";
    sendCmd("t0.txt=" + mytext);
    delay(100);
  }
  delay(2000);

  //Fading out example
  message = "Fading out...";
  for(i=message.length(); i>=0; i--)
  {
    mytext = "\"" + message.substring(0,i) + "\"";
    sendCmd("t0.txt=" + mytext);
    delay(100);
  }
  delay(2000);

  //Flashing example
  message="Flashing";
  for(i=0; i<10; i++)
  {
    mytext = "\"" + message + "\"";
    sendCmd("t0.txt=" + mytext);
    delay(250);
    mytext = "\"\"";
    sendCmd("t0.txt=" + mytext);
    delay(250);    
  }
  delay(2000);
}
